// -*- c++ -*-
/*
  Copyright 2003 John Knottenbelt
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#if !defined __DEMUXER_H
#define __DEMUXER_H

#include "source.h"

class Tuner;

class Demuxer : public Source, public Sink {
public:
  enum PESType { Video, Audio, Teletext };

protected:

  friend class Tuner;
  Demuxer(Tuner *tuner, int pid, PESType pestype);
  virtual ~Demuxer();

public:

  int getPID() const { return pid; }

  virtual void receiveData(unsigned char *data, unsigned size);
  virtual bool subscribe(Sink *s);
  virtual void unsubscribe(Sink *s);
  virtual void notifyUnsubscribe(Source *s);

protected:
  virtual bool openDemux();
  virtual void closeDemux();
  virtual void setTSFilt( bool dmxOther );

private:
  Tuner *tuner;
  int pid;
  int demuxFD;
  int pesType;
};

#endif // __DEMUXER_H
